header
lorom
org $8F70
NOP          ; \
NOP          ;  |
NOP          ;  |
NOP          ;  |
NOP          ;  |
NOP          ;  |
NOP          ;  |
NOP          ;  |
NOP          ;  |
NOP          ;  | Stop the original counter.
NOP          ;  |
NOP          ;  |
NOP          ;  |
NOP          ;  |
NOP          ;  |
NOP          ;  |
NOP          ;  |
NOP          ;  |
NOP          ;  |
NOP          ; /

org $8FD8
JML Check_One  ; Jump to the new code.
NOP

; -------------------------------------------
org $13A340 ; address to put code
; -------------------------------------------
db "STAR" ; Write RATS tag
dw Endcodeblock-Startcodeblock
dw Endcodeblock-Startcodeblock^#$FFFF
; -------------------------------------------
Startcodeblock: ; code starts here
; -------------------------------------------

Check_One:
LDA $7EC100   ;\
CMP #$3A      ; |  If greater than a certain amount...
BCS Set_Zero  ;/   ...branch off.

Check_Two:
LDA $7EC101   ;\
CMP #$3A      ; |  If greater than a certain amount...
BCS Set_Zero2 ;/   ...branch off.
BRA CoinOne   ;    Branch off to setting the values shown in the status bar.

Set_Zero:
LDA #$00      ;\
STA $7EC100   ; |  Set the address to zero.
BRA Check_Two ;/

Set_Zero2:
LDA #$00      ;\
STA $7EC101   ;/   Set the address to zero.

CoinOne:
LDA $7E0DBF   ;\
CMP #$0A      ; |  If less than #$0A...
BCC CoinTwo   ;/   ...go check the next digit.

LDA $7EC100   ;\
CMP #$09      ; |  If the tens digit is 9...
BCC Increase  ;/   ...check final digit.

LDA $7EC101   ;\
CMP #$09      ; |  If the hundreds digit is 9...
BCC Increase  ;/   ...draw digits.

LDA #$09      ;\  Set the digit to 9.
STA $7E0DBF   ;/
LDA #$09      ;\  Set the digit to 9.
STA $7EC100   ;/
LDA #$09      ;\  Set the digit to 9.
STA $7EC101   ;/
BRA DrawCoin

Increase:
LDA $7EC100   ;\
INC           ; |  Increase the value of the next digit.
STA $7EC100   ;/

LDA $7E0DBF   ;\
SEC           ; |
SBC #$0A      ; |  Subtract #$0A from the digit...
STA $7E0DBF   ;/   ...so we get the right value.

CoinTwo:
LDA $7EC100   ;\
CMP #$0A      ; |  If less than #$0A...
BCC CoinThree ;/   ...go check the next digit.

LDA $7EC101   ;\
CMP #$09      ; |  If the hundreds digit is 9...
BCC Increase2 ;/   ...draw digits.

LDA #$09      ;\  Set the digit to 9.
STA $7E0DBF   ;/
LDA #$09      ;\  Set the digit to 9.
STA $7EC100   ;/
LDA #$09      ;\  Set the digit to 9.
STA $7EC101   ;/
BRA DrawCoin

Increase2:
LDA $7EC101   ;\
INC           ; |  Increase the value of the next digit.
STA $7EC101   ;/

LDA $7EC100   ;\
SEC           ; |
SBC #$0A      ; |  Subtract #$0A from the digit...
STA $7EC100   ;/   ...so we get the right value.

CoinThree:
LDA $7EC101   ;\
CMP #$0A      ; |  If less than #$0A...
BCC DrawCoin  ;/   ...draw the values to the status bar.

LDA #$09      ;\  Set the digit to 9.
STA $7E0DBF   ;/
LDA #$09      ;\  Set the digit to 9.
STA $7EC100   ;/
LDA #$09      ;\  Set the digit to 9.
STA $7EC101   ;/

DrawCoin:
LDA $7E0DBF   ;\
STA $7E0F14   ; |
LDA $7EC100   ; | Write the values of the digits to the status bar...
STA $7E0F13   ; | ...at the location of the original counter.
LDA $7EC101   ; |
STA $7E0F12   ;/

LDA $1422     ;\
CMP #$05      ; | We hooked into the original Yoshi Coin code, so we're restoring it here so we don't mess up anything!
JML $008FDD   ;/

; -------------------------------------------
Endcodeblock: ; code ends here
; -------------------------------------------


; -------------------------------------------
org $14A340 ; address to put code
; -------------------------------------------
db "STAR" ; Write RATS tag
dw Endcodeblock2-Startcodeblock2
dw Endcodeblock2-Startcodeblock2^#$FFFF
; -------------------------------------------
Startcodeblock2: ; code starts here
; -------------------------------------------

LDA $7EC102      ;\
CMP #$03         ; |  If $C102 is higher than #$02...
BCS Reset_Count  ; |  ...branch off...
BRA Check1       ;/   ...else continue with the code.

Reset_Count:
LDA #$00         ;\
STA $7EC102      ;/   Zero out $C102 so things won't wig out when we try to pay for something.

Check1:
LDA $7EC101      ;\
CMP $7EC103      ; |  If our hundreds digit is equal to the amount we need...
BEQ Check2       ; |  ...check the next digit...
BCS Pay          ; |  ...or go ahead and pay if it's greater...
BCC Midway2      ;/   ...or return that we don't have enough.

Check2:
LDA $7EC100      ;\
CMP $7EC104      ; |  If our tens digit is equal to the amount we need...
BEQ Check3       ; |  ...check the next digit...
BCS Pay          ; |  ...or go ahead and pay if it's greater...
BCC Midway2      ;/   ...or return that we don't have enough.

Check3:
LDA $7E0DBF      ;\
CMP $7EC105      ; |  If our ones digit is equal to or greater than the amount we need...
BEQ Pay          ; |  ...we go pay the price...
BCS Pay          ; | 
BCC Midway2      ;/   ...else return that we don't have enough.

Pay:
LDA $7EC105      ;\
CMP #$00         ; |  If the price is non-existant for this digit...
BEQ Counter2     ;/   ...just ignore this section and check the next digit.

LDA $7E0DBF      ;\
CMP $7EC105      ; |  If the ones digit is less than the ones price...
BCC Pull1        ;/   ...jump off to pulling from the next digit.
Drain1:
LDA $7E0DBF      ;\
SEC              ; |
SBC $7EC105      ; |  Subtract the price from the digit.
STA $7E0DBF      ; |
BRA Counter2     ;/   Next digit...

Pull1:
LDA $7EC100      ;\
DEC              ; |  Decrease the next digit by one...
STA $7EC100      ;/
LDA $7E0DBF      ;\
CLC              ; |
ADC #$0A         ; |  ...and add it to the current digit in the form of #$0A, 10 decimal.
STA $7E0DBF      ; |
BRA Drain1       ;/   Subtract from the digit.

Midway2:
BRA Midway3      ;    Midway stop for the return, so we don't get an error.

Counter2:
LDA $7EC104      ;\
CMP #$00         ; |  If the price is non-existant for this digit...
BEQ Counter3     ;/   ...just ignore this section and check the next digit.

LDA $7EC100      ;\
CMP $7EC104      ; |  Checking the next digit against the price...
BCC Pull2        ;/
Drain2:
LDA $7EC100      ;\
SEC              ; |
SBC $7EC104      ; | Drain the price from the digit again.
STA $7EC100      ; |
BRA Counter3     ;/

Pull2:
LDA $7EC101      ;\
DEC              ; |  Decreasing again.
STA $7EC101      ;/
LDA $7EC100      ;\
CLC              ; |
ADC #$0A         ; |  Adding to give us a safe and accurate subtraction again.
STA $7EC100      ; |
BRA Drain2       ;/

Midway3:
BRA CantPay      ;    Midway stop for the return, so we don't get an error.

Counter3:
LDA $7EC103      ;\
CMP #$00         ; |  If the price is non-existant for this digit...
BEQ CanPay       ;/   ...just ignore this section and pay immediately.

LDA $7EC101      ;\ 
SEC              ; |
SBC $7EC103      ; | Drain the price from the final digit.
STA $7EC101      ; |
BRA CanPay       ;/

CanPay:
LDA #$01
STA $7EC102      ;   Return that we have enough coins to buy the effect.
BRA Return

CantPay:
LDA #$02
STA $7EC102      ;   Return that we don't have enough coins to buy. 
Return:
RTL

; -------------------------------------------
Endcodeblock2: ; code ends here
; -------------------------------------------